#!/usr/bin/php
<?php

function extract_required_files($filename)
{
   $list = array();

   $content = file_get_contents($filename);
   preg_match_all('{require_once\(\'(?P<filename>.*?)\'\)}', $content, $matches);
   unset($content);

   foreach($matches['filename'] as $m) {
      $list[] = $m;
      $list = array_unique(array_merge($list, extract_required_files($m)));
   }

   return $list;
}

chdir(dirname($argv[1]));
$list = extract_required_files($argv[1]);
$list[] = $argv[1];

file_put_contents($argv[2], "<?php");
foreach($list as $l) {
   $content = preg_replace('{<\?php|require_once\(.*?\);|\?>}', '', file_get_contents($l));
   file_put_contents($argv[2], $content, FILE_APPEND);
}
file_put_contents($argv[2], "?>\n", FILE_APPEND);

?>
